<template>
  <div class="relative flex flex-col w-full max-w-xs pb-4 rounded-lg">
    <h3
      class="
        sticky
        top-0
        p-4
        text-lg
        font-medium
        leading-6
        text-gray-800
        capitalize
        bg-white
        shadow-md
      "
    >
      {{ status }}
    </h3>
    <VueDraggableNext
      class="w-full h-full px-2 mt-2"
      item-key="id"
      ghost-class="bg-blue-50"
      group="projects"
      :list="list"
      :animation="200"
      @change="movedElement"
      @update="update"
    >
      <transition-group>
        <article
          v-for="element in list"
          :key="element.id"
          class="p-4 mb-2 bg-white rounded-lg shadow-md cursor-pointer"
        >
          <header class="flex justify-between pb-3">
            <div
              class="
                flex
                items-center
                px-2.5
                py-1
                bg-green-50
                text-xs
                leading-4
                font-medium
                text-green-800
                rounded-lg
              "
            >
              <IconClock class="w-3.5 h-3.5 mr-2" />
              {{ element.created_at }}
            </div>
            <button
              class="
                flex
                items-center
                justify-center
                w-5
                h-5
                bg-gray-100
                rounded-md
              "
            >
              <IconEllipsis class="w-1 h-3" />
            </button>
          </header>
          <p class="pb-6 text-base leading-6 font-medium text-gray-700">
            {{ element.name }}
          </p>
          <footer class="flex items-center justify-between">
            <div class="w-6 h-6 bg-gray-200 rounded-full"></div>
            <div class="flex items-center">
              <button
                class="
                  flex
                  justify-center
                  items-center
                  px-2.5
                  py-0.5
                  mr-3
                  bg-gray-100
                  rounded-xl
                  text-xs
                  leading-4
                  font-medium
                  text-gray-600
                "
              >
                <IconClip class="w-2 h-4 mr-1.5" />
                2
              </button>
              <button>
                <IconChat class="w-5 h-5" />
              </button>
            </div>
          </footer>
        </article>
      </transition-group>
    </VueDraggableNext>
  </div>
</template>
<script>
import { VueDraggableNext } from 'vue-draggable-next';

import IconEllipsis from '@/components/Icons/IconEllipsis';
import IconClock from '@/components/Icons/IconClock';
import IconChat from '@/components/Icons/IconChat';
import IconClip from '@/components/Icons/IconClip';

export default {
  name: 'DraggableBoard',

  components: {
    VueDraggableNext,
    IconEllipsis,
    IconClock,
    IconChat,
    IconClip,
  },

  props: {
    list: {
      type: Array,
      required: true,
    },

    status: {
      type: String,
      required: true,
    },
  },

  methods: {
    movedElement(element) {
      console.log('element', element);
    },

    update() {
      console.log('update');
    },
  },
};
</script>
